#include "FormParentalOverride.h"
#include "FormVO2Max.h"
#include "Windows.h"
#include <iostream>
#include "wtypes.h"
//#include <User32.dll>
//#using <User32.dll>
#using <System.dll>
#using <System.Windows.Forms.dll>
#using <System.Drawing.dll>
#include <time.h>
#include <ctime>


#pragma once

namespace PurpleHealth {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Collections::Generic;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::IO;
	using namespace System::Text;
	using namespace std;


	/// <summary>
	/* This is basically the main form that the user sees when they first log into the program. It is called "FormOutOfTime"
	because it was initially just meant to pop up when they were out of time, instead of functioning as the general control
	panel it is now. Consider naming it something better. THis form launches FormVO2Max if the program has never been run before. This form also remains open as a task bar icon when the user begins a session
	*/
	/// </summary>


	public ref class FormOutOfTime : public System::Windows::Forms::Form
	{
	protected: 
		//initial screen width
	private: static int scLength =400;
			 //initial screen height
	private: static int scWidth =400;

			 //10 minute warning message
	private: static bool msgDis=false;
			 //current date
	private: static double day = 0;
	private: static double month = 0;
	private: static double year = 0;

			 //last time the user used the program
	private: static double oldDay = 0;
	private: static double oldMonth = 0;
	private: static double oldYear = 0;

			 //User Defined Variables
			 //Tracks user's calories burt (from uploaded data)
	private: static double dCalsBurnt=0;
			 //Tracks the number of calories a user has to burn to gain an hour of time
	private: static double dCalsPerHour=200;
			 //Tempory string to hold stuff
	private: static String ^ sTemp;
			 //Tracks a user's daily time (min)
	private: static double dTime=30;
			 //Tracks a user's flex time (this carries over day to day)(min)
	private: static double dFlexTime=0;
			 //Integer used to hold dTime when a nice, integer output is preferable to a double
	private: static int nTime=0;
			 //Tracks the amount of time a user is allowed per day (before requiring exercise). THis is
			 //not currently used by anything (min)
	private: static double dDailyAllowance=60;
			 //Pointer to the location of the FormVO2Max object which is opened when the user begins the session
	private: System::Windows::Forms::Form^ formVO2Max;

			 //Machine Defined Variables

	private: System::Windows::Forms::Button^  btnOverride;
	private: System::Windows::Forms::Button^  btnUploadData;

	private: System::Windows::Forms::Button^  btnLogout;

	private: System::Windows::Forms::Label^  lblTimeLeft;

	private: System::ComponentModel::IContainer^  components;
	private: System::Windows::Forms::Button^  btnBeginSession;
	private: System::Windows::Forms::Timer^  timerSession;
	private: System::Windows::Forms::Form^ formParentalOverride;

	private:

		/// <summary>
		/// Required designer variable.
		/// </summary>

	public:
		FormOutOfTime(void)
		{
			RECT desktop;
			// Get a handle to the desktop window
			const HWND hDesktop = GetDesktopWindow();
			// Get the size of screen to the variable desktop
			GetWindowRect(hDesktop, &desktop);
			// The top left corner will have coordinates (0,0)
			// and the bottom right corner will have coordinates
			// (horizontal, vertical)
			scLength = desktop.right;

			scWidth = desktop.bottom;

			GetLocalTime();

			//Create the items on the screen (code generated by visual editor)
			InitializeComponent();
			//Create the tray icon that the user sees and can use when this window is hidden code from MSDN
			CreateTrayIcon();
			//Retrieves the users timing info from the saved file
			LoadTime();
			//Updates the various places that the program shows time
			UpdateTime();

			LoadVO2Max();


		}
		//Getting local time
		void GetLocalTime()
		{
			time_t longtime;   // get time now
			struct tm * aTime;
			time ( &longtime);
			aTime=localtime(&longtime);
			day = aTime->tm_mday;
			month = aTime->tm_mon + 1; // Month is 0 - 11, add 1 to get a jan-dec 1-12 concept
			year = aTime->tm_year + 1900; // Year is # years since 1900

		}
		//Creates the tray icon, and defines its properties
		void CreateTrayIcon()
		{
			this->components2 = gcnew System::ComponentModel::Container;
			this->contextMenu = gcnew System::Windows::Forms::ContextMenu;
			this->menuItemOpen = gcnew System::Windows::Forms::MenuItem;
			this->menuItemTime = gcnew System::Windows::Forms::MenuItem;

			// Initialize contextMenu
			array<System::Windows::Forms::MenuItem^>^temp0 = {this->menuItemOpen};
			this->contextMenu->MenuItems->AddRange( temp0 );
			array<System::Windows::Forms::MenuItem^>^temp1 = {this->menuItemTime};
			this->contextMenu->MenuItems->AddRange( temp1 );

			// Initialize Menu Items
			this->menuItemOpen->Index = 0;
			this->menuItemOpen->Text = "Open";
			this->menuItemOpen->Click += gcnew System::EventHandler( this, &FormOutOfTime::menuItemOpen_Click );

			this->menuItemTime->Index = 1;
			this->menuItemTime->Text = "Check Time";
			this->menuItemTime->Click += gcnew System::EventHandler( this, &FormOutOfTime::menuItemTime_Click );

			// Create the NotifyIcon.
			this->trayIconFormOutOfTime = gcnew System::Windows::Forms::NotifyIcon( this->components2 );

			// The Icon property sets the icon that will appear
			// in the systray for this application.
			trayIconFormOutOfTime->Icon = gcnew System::Drawing::Icon( "Balife.ico" );

			// The ContextMenu property sets the menu that will
			// appear when the systray icon is right clicked.
			trayIconFormOutOfTime->ContextMenu = this->contextMenu;

			// The Text property sets the text that will be displayed,
			// in a tooltip, when the mouse hovers over the systray icon.
			trayIconFormOutOfTime->Text = "Balife";
			trayIconFormOutOfTime->Visible = true;

			// Handle the DoubleClick event to activate the form.
			trayIconFormOutOfTime->DoubleClick += gcnew System::EventHandler( this, &FormOutOfTime::trayIconFormOutOfTime_DoubleClick );
		}
	private:
		//Reads user's daily time (dTime), flex time aka anytime-time (dFlexTime), Number of calories required to earn an
		//hour of additional time (dCalsPerHour), and the user's current daily allowance of time (not currently used at all)(dDailyAllowance)
		void LoadTime(){
			//Begin read of the timing file
			System::IO::StreamReader ^ sr = gcnew System::IO::StreamReader("Time.time", System::Text::Encoding::Unicode);
			//Read the info from the file and put in respective global variables (file contains seven lines)
			dTime=System::Convert::ToDouble(sr->ReadLine());
			dFlexTime=System::Convert::ToDouble(sr->ReadLine());
			dCalsPerHour=System::Convert::ToDouble(sr->ReadLine());
			dDailyAllowance=System::Convert::ToDouble(sr->ReadLine());
			oldDay=System::Convert::ToDouble(sr->ReadLine());
			oldMonth=System::Convert::ToDouble(sr->ReadLine());
			oldYear=System::Convert::ToDouble(sr->ReadLine());
			sr->Close();
			//If last session is not the current day, add daily allowance time
			if ((oldDay==day)&&(oldMonth==month)&&(oldYear==year)){
				dTime+=0;
			}
			else{
				dTime+=dDailyAllowance;
			}
			SaveTime();
			UpdateTime();
		}
		//Updates the label in this form, as well as the tray icon tooltip to say how much time is left
		void GetDesktopResolution(int horizontal, int vertical){
			RECT desktop;
			// Get a handle to the desktop window
			const HWND hDesktop = GetDesktopWindow();
			// Get the size of screen to the variable desktop
			GetWindowRect(hDesktop, &desktop);
			// The top left corner will have coordinates (0,0)
			// and the bottom right corner will have coordinates
			// (horizontal, vertical)
			horizontal = desktop.right;
			vertical = desktop.bottom;

		}

		void UpdateTime(){
			nTime = (int)(dTime+dFlexTime);
			if((nTime>0)){
				this->lblTimeLeft->Text = L"You have "+nTime+" minutes to browse today.";
				trayIconFormOutOfTime->Text="You have "+nTime+" minutes to browse today.";
			}
			else{
				this->lblTimeLeft->Text = L"You currently have no time left. Wait until tomorrow, or upload heart rate data to get more time.";
				trayIconFormOutOfTime->Text="Out of Time"; //Cant contain too many characters i.e. above message is too long
			}
			if ((nTime==10)&&!msgDis){
				MessageBox::Show("You have 10 minutes left. Please save your work.");
			}
		}

		//Takes the current timing data and outputs it to the time file (done quite frequenty, since multiple parts of the program rely on
		//up to date info from this file
		void SaveTime(){
			//Define the location of the time info file 
			String^ path = "Time.time";
			//CHeck if file exists, delete if it does (can cause problems, since multiple forms are reading and writing to this file)
			if ( File::Exists( path ) )
			{
				File::Delete( path );
			}

			//Create the file.

			FileStream^ fs = File::Create( path );
			UnicodeEncoding^ uniEncoding = gcnew UnicodeEncoding;

			//Write the timing data to the file in unicode encoding (important to note if you open the file with a
			//tect editor for debugging)
			String^ tempString = System::Convert::ToString(dTime)+"\r";
			fs->Write( uniEncoding->GetBytes( tempString ), 0, uniEncoding->GetByteCount( tempString ) );
			tempString = System::Convert::ToString(dFlexTime)+"\r";
			fs->Write( uniEncoding->GetBytes( tempString ), 0, uniEncoding->GetByteCount( tempString ) );
			tempString = System::Convert::ToString(dCalsPerHour)+"\r";
			fs->Write( uniEncoding->GetBytes( tempString ), 0, uniEncoding->GetByteCount( tempString ) );
			tempString = System::Convert::ToString(dDailyAllowance)+"\r";
			fs->Write( uniEncoding->GetBytes( tempString ), 0, uniEncoding->GetByteCount( tempString ) );
			tempString = System::Convert::ToString(day)+"\r";
			fs->Write( uniEncoding->GetBytes( tempString ), 0, uniEncoding->GetByteCount( tempString ) );
			tempString = System::Convert::ToString(month)+"\r";
			fs->Write( uniEncoding->GetBytes( tempString ), 0, uniEncoding->GetByteCount( tempString ) );
			tempString = System::Convert::ToString(year)+"\r";
			fs->Write( uniEncoding->GetBytes( tempString ), 0, uniEncoding->GetByteCount( tempString ) );
			fs->Close();
		}

		//Variables required for tray icon
	private:
		//Icon itself
		System::Windows::Forms::NotifyIcon^ trayIconFormOutOfTime;
		//Menu that comes up on right click
		System::Windows::Forms::ContextMenu^ contextMenu;
		//Items in above menu
		System::Windows::Forms::MenuItem^ menuItemOpen;
		System::Windows::Forms::MenuItem^ menuItemTime;
		//Misc
		System::Windows::Forms::Button^  btnExit;
		System::Windows::Forms::Label^  label1;
		System::ComponentModel::IContainer^ components2;


	private:
		//Handles the event of a double click on the tray icon, action listener 
		void trayIconFormOutOfTime_DoubleClick( Object^ /*Sender*/, EventArgs^ /*e*/ )
		{

			// Show the form when the user double clicks on the notify icon.
			// Set the WindowState to normal if the form is minimized.
			if ( this->WindowState == FormWindowState::Minimized )
				this->WindowState = FormWindowState::Normal;

			// Activate the form.
			this->Activate();
			this->Show();
			//Get newest time data
			LoadTime();

			//Show newest tiem data
			UpdateTime();


			//Stop timer so that hte user doesnt lose any time while in the full screen controol panel (possible avenue for
			//a user to cheat the system?)
			timerSession->Enabled=false;
		}
		//Handles when user clicks the menu item saying "Open": opens the window the same way the double click does (since
		//it's the same code, perhaps ove into a function?)
		void menuItemOpen_Click( Object^ /*Sender*/, EventArgs^ /*e*/ )
		{
			if ( this->WindowState == FormWindowState::Minimized )
				this->WindowState = FormWindowState::Normal;
			// Show the form again
			this->Activate();
			this->Show();
			//Get newest time data
			LoadTime();
			//Show newest tiem data
			UpdateTime();
			//Stop timer so that hte user doesnt lose any time while in the full screen controol panel (possible avenue for
			//a user to cheat the system?)
			timerSession->Enabled=false;

		}
		//handles click of "Time" menue item: shows the user their time remaining in a popup
		void menuItemTime_Click( Object^ /*Sender*/, EventArgs^ /*e*/ )
		{
			//Create pop up dialog with the user's reamaining time
			nTime=(int)(dTime+dFlexTime);
			MessageBox::Show("You have "+nTime+" minutes left.");
		}

		//Reads user's VO2 Max data
		void LoadVO2Max(){
			try{
				//Define the location of the time info file 
				String^ path = "VO2Max.dat";
				//CHeck if file exists, if it does, load it
				if ( File::Exists( path ) )
				{
					//Begin read of the file
					System::IO::StreamReader ^ sr = gcnew System::IO::StreamReader("VO2Max.dat", System::Text::Encoding::Unicode);
					//Read the info from the file and put in respective global variables (file contains four lines, VO2 Max, Weight, Age, and Gender "M" or "f")
					dVO2Max=System::Convert::ToDouble(sr->ReadLine());
					dWeight=System::Convert::ToDouble(sr->ReadLine());
					dAge=System::Convert::ToDouble(sr->ReadLine());
					chGender=System::Convert::ToChar(System::Convert::ToInt32(sr->ReadLine()));
					sr->Close();
				}
				//If the file doesnt exist, launch the form that will create a new one
				else{
					formVO2Max = gcnew FormVO2Max;
					formVO2Max->ShowDialog();
					LoadVO2Max();
				}

			}catch(...){
				formVO2Max = gcnew FormVO2Max;
				formVO2Max->ShowDialog();
				LoadVO2Max();


			}
		}
		//Uses VO2Max data and heart rate data to figure out calories burned. Calculates based on five second intervals
		//**************Add checking if HR is within exercise range******************************
		void CalculateCalories(){
			dCalsBurnt=0;
			//Calculates the users max HR
			double dMaxHR = 208 - (0.7*dAge);
			double dPrecentHRMax=0;
			double dPrecentVO2Max=0;
			double dAverageHR=0;
			double dDuration=0;
			//Parse through list and remove data tha does not fall between 41% and 80% of VO2Max
			for(int i=0;i<listHRData->Count; i++){
				//Calculate % of max HR
				dPrecentHRMax=System::Convert::ToDouble(listHRData[i])*100/dMaxHR;
				//Calculate % of VO2 max
				dPrecentVO2Max=1.5472*dPrecentHRMax-57.53;
				if(dPrecentVO2Max<41||dPrecentVO2Max>80){
					//Remove data not in the appropriate range
					listHRData->RemoveAt(i);
					//Decriment the counter to ensure no data is skipped
					i--;
				}
			}

			if(listHRData->Count==0){
				MessageBox::Show("None of the provided data was within an acceptable range to be considered exercise. Please get your heart rate higher next time.");
			}else{

				//Calculate the average heartrate throughout the etire exercise period
				for(int i=0;i<listHRData->Count;i++){
					dAverageHR+=System::Convert::ToDouble(listHRData[i]);
				}
				dAverageHR/=listHRData->Count;
				dDuration = System::Convert::ToDouble(listHRData->Count)/3600;
				//Check gender and then run caloric burn calculations based on that
				if(chGender='F'){
					dCalsBurnt=((-59.3954 + (0.45*dAverageHR) + (0.380*dVO2Max) + (0.103*dWeight) + (0.274*dAge))/4.184)*60*dDuration;
				}
				else if(chGender='M'){
					dCalsBurnt=((-95.7735 + (0.634*dAverageHR) + (0.404*dVO2Max) + (0.394*dWeight) + (0.271*dAge))/4.184)*60*dDuration;
				}else{
					MessageBox::Show("Error: Gender must be specified in VO2max file");
				}
			}



			//Adds flex time based on calories burnt, and the number of calories required to gan an hour
			dFlexTime+=dCalsBurnt/(dCalsPerHour/60);

			//Create integers for visually nice output
			int nTempCals = (int)dCalsBurnt;
			int nTempTime = (int)(dCalsBurnt/(dCalsPerHour/60));
			nTime=(int)(dFlexTime + dTime);
			//Update label to reflect user's added time
			if(nTempCals>0)
				this->lblTimeLeft->Text = L"You have burnt "+ nTempCals +" calories giving you " + nTempTime + " additional minutes. You now have "+(nTime)+" minutes remaining.";

			//Save the uploaded info
			SaveTime();
			listHRData->Clear();
		}

		///User defined variables
		///Variables used to hold heart rate and oxygen data
	private: static System::Collections::Generic::List<String^>^ listHRData = gcnew List<String^>();
			 static System::Collections::Generic::List<String^>^ listOxyData = gcnew List<String^>();
			 static double dVO2Max;
			 static double dWeight;
			 static double dAge;
			 static char chGender;

	private: System::Windows::Forms::OpenFileDialog^  openHeartRateFile;


	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~FormOutOfTime()
		{
			if (components)
			{
				delete components;
			}
		}


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)

		{

			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(FormOutOfTime::typeid));
			this->btnOverride = (gcnew System::Windows::Forms::Button());
			this->btnUploadData = (gcnew System::Windows::Forms::Button());
			this->btnLogout = (gcnew System::Windows::Forms::Button());
			this->lblTimeLeft = (gcnew System::Windows::Forms::Label());
			this->openHeartRateFile = (gcnew System::Windows::Forms::OpenFileDialog());
			this->btnBeginSession = (gcnew System::Windows::Forms::Button());
			this->timerSession = (gcnew System::Windows::Forms::Timer(this->components));
			this->btnExit = (gcnew System::Windows::Forms::Button());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->SuspendLayout();
			// 
			// btnOverride
			// 
			this->btnOverride->BackColor = System::Drawing::Color::Transparent;
			this->btnOverride->FlatAppearance->BorderSize = 0;
			this->btnOverride->FlatAppearance->MouseDownBackColor = System::Drawing::Color::DarkGray;
			this->btnOverride->FlatAppearance->MouseOverBackColor = System::Drawing::Color::LightGray;
			this->btnOverride->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->btnOverride->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnOverride.Image")));
			this->btnOverride->Location = System::Drawing::Point(scLength/12*4-40, scWidth/12*7);
			this->btnOverride->Name = L"btnOverride";
			this->btnOverride->Size = System::Drawing::Size(150, 150);
			this->btnOverride->TabIndex = 5;
			this->btnOverride->UseVisualStyleBackColor = false;
			this->btnOverride->Click += gcnew System::EventHandler(this, &FormOutOfTime::btnOverride_Click);
			// 
			// btnUploadData
			// 
			this->btnUploadData->BackColor = System::Drawing::Color::Transparent;
			this->btnUploadData->BackgroundImageLayout = System::Windows::Forms::ImageLayout::None;
			this->btnUploadData->FlatAppearance->BorderSize = 0;
			this->btnUploadData->FlatAppearance->MouseDownBackColor = System::Drawing::Color::DarkGray;
			this->btnUploadData->FlatAppearance->MouseOverBackColor = System::Drawing::Color::LightGray;
			this->btnUploadData->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->btnUploadData->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnUploadData.Image")));
			this->btnUploadData->Location = System::Drawing::Point(scLength/12*7-40, scWidth/12*7);
			this->btnUploadData->Name = L"btnUploadData";
			this->btnUploadData->Size = System::Drawing::Size(150, 150);
			this->btnUploadData->TabIndex = 6;
			this->btnUploadData->UseVisualStyleBackColor = false;
			this->btnUploadData->Click += gcnew System::EventHandler(this, &FormOutOfTime::btnAddTime_Click);
			// 
			// btnLogout
			// 
			this->btnLogout->BackColor = System::Drawing::Color::Transparent;
			this->btnLogout->FlatAppearance->BorderSize = 0;
			this->btnLogout->FlatAppearance->MouseDownBackColor = System::Drawing::Color::DarkGray;
			this->btnLogout->FlatAppearance->MouseOverBackColor = System::Drawing::Color::LightGray;
			this->btnLogout->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->btnLogout->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnLogout.Image")));
			this->btnLogout->Location = System::Drawing::Point(scLength/12*10-40, scWidth/12*7);
			this->btnLogout->Name = L"btnLogout";
			this->btnLogout->Size = System::Drawing::Size(150, 150);
			this->btnLogout->TabIndex = 7;
			this->btnLogout->UseVisualStyleBackColor = false;
			this->btnLogout->Click += gcnew System::EventHandler(this, &FormOutOfTime::btnLogout_Click);
			// 
			// lblTimeLeft
			// 
			this->lblTimeLeft->BackColor = System::Drawing::Color::Transparent;
			this->lblTimeLeft->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->lblTimeLeft->Location = System::Drawing::Point(scLength/2-521, scWidth*0.38021);
			this->lblTimeLeft->Name = L"lblTimeLeft";
			this->lblTimeLeft->Size = System::Drawing::Size(1022, 20);
			this->lblTimeLeft->TabIndex = 9;
			this->lblTimeLeft->Text = L"You currently have no time left. Wait until tomorrow, or upload heart rate data t" 
				L"o get more time.";
			this->lblTimeLeft->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->lblTimeLeft->Click += gcnew System::EventHandler(this, &FormOutOfTime::lblTimeLeft_Click);
			// 
			// openHeartRateFile
			// 
			this->openHeartRateFile->DefaultExt = L"csv";
			this->openHeartRateFile->FileName = L"openHeartRateFile";
			this->openHeartRateFile->Filter = L"Heart Rate Data Files|*.csv|All files|*.*";
			this->openHeartRateFile->InitialDirectory = L"c:";
			this->openHeartRateFile->Title = L"Upload Heart Rate Data";

			// 
			// btnBeginSession
			// 
			this->btnBeginSession->BackColor = System::Drawing::Color::Transparent;
			this->btnBeginSession->FlatAppearance->BorderSize = 0;
			this->btnBeginSession->FlatAppearance->MouseDownBackColor = System::Drawing::Color::DarkGray;
			this->btnBeginSession->FlatAppearance->MouseOverBackColor = System::Drawing::Color::LightGray;
			this->btnBeginSession->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->btnBeginSession->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnBeginSession.Image")));
			this->btnBeginSession->Location = System::Drawing::Point(scLength/12*1-40, scWidth/12*7);
			this->btnBeginSession->Name = L"btnBeginSession";
			this->btnBeginSession->Size = System::Drawing::Size(150, 150);
			this->btnBeginSession->TabIndex = 10;
			this->btnBeginSession->UseVisualStyleBackColor = false;
			this->btnBeginSession->Click += gcnew System::EventHandler(this, &FormOutOfTime::btnBeginSession_Click);
			// 
			// timerSession
			// 
			this->timerSession->Interval = 60000;
			this->timerSession->Tick += gcnew System::EventHandler(this, &FormOutOfTime::timerSession_Tick);
			// 
			// btnExit
			// 
			this->btnExit->Location = System::Drawing::Point(scLength-90, scWidth-30);
			this->btnExit->Name = L"btnExit";
			this->btnExit->Size = System::Drawing::Size(75, 23);
			this->btnExit->TabIndex = 11;
			this->btnExit->Text = L"Exit";
			this->btnExit->UseVisualStyleBackColor = true;
			this->btnExit->Click += gcnew System::EventHandler(this, &FormOutOfTime::btnExit_Click);
			// 
			// label1
			// 
			this->label1->BackColor = System::Drawing::Color::Transparent;
			this->label1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label1->Location = System::Drawing::Point(300, 865);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(1000, 20);
			this->label1->TabIndex = 12;
			this->label1->Text = L"Copyright Balife Inc. 2012";
			this->label1->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// FormOutOfTime
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->AutoValidate = System::Windows::Forms::AutoValidate::EnablePreventFocusChange;
			this->BackgroundImage = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"$this.BackgroundImage")));
			this->BackgroundImageLayout = System::Windows::Forms::ImageLayout::Stretch;
			this->ClientSize = System::Drawing::Size(1024, 768);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->btnExit);
			this->Controls->Add(this->btnBeginSession);
			this->Controls->Add(this->lblTimeLeft);
			this->Controls->Add(this->btnLogout);
			this->Controls->Add(this->btnUploadData);
			this->Controls->Add(this->btnOverride);
			this->DoubleBuffered = true;
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::None;
			this->Name = L"FormOutOfTime";
			this->RightToLeftLayout = true;
			this->Text = L"FormOutOfTime";
			this->TopMost = true;
			this->WindowState = System::Windows::Forms::FormWindowState::Maximized;
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &FormOutOfTime::FormOutOfTime_FormClosing);
			this->Load += gcnew System::EventHandler(this, &FormOutOfTime::FormOutOfTime_Load);
			this->ResumeLayout(false);

		}
#pragma endregion
		//Garbage
	private: System::Void openFileDialog1_FileOk(System::Object^  sender, System::ComponentModel::CancelEventArgs^  e) {
			 }
	private: System::Void FormOutOfTime_Load(System::Object^  sender, System::EventArgs^  e) {

			 }

			 //Deals with parental overide request. Launches the parental overide form, then when that form is done, reloads and
			 //updates time data
	private: System::Void btnOverride_Click(System::Object^  sender, System::EventArgs^  e) {
				 formParentalOverride = gcnew FormParentalOverride;
				 formParentalOverride->ShowDialog();
				 LoadTime();
				 UpdateTime();
				 LoadVO2Max();

			 }
			 //Handles log off button. Logs out of windows
	private: System::Void btnLogout_Click(System::Object^  sender, System::EventArgs^  e) {
				 ExitWindowsEx(EWX_LOGOFF, SHTDN_REASON_MAJOR_APPLICATION);
				 //ExitWindows(0, 0);
			 }

			 //Handes the begin session button. minimizes to tray if the user has time, tells the user their out if they dont
	private: void btnBeginSession_Click(System::Object ^ sender, System::EventArgs ^ e)

			 {
				 //Figure out the total time the user has available to use
				 nTime=(int)(dFlexTime + dTime);
				 //Do they have any time?
				 //If yes, hide this window
				 if(nTime>0){
					 if(!timerSession->Enabled){
						 MessageBox::Show("You have "+nTime+" minutes to browse.");
						 timerSession->Enabled=true;
						 //int nTime=(int)(dTime+dFlexTime);
						 //CSystemTray::MinimiseToTray(this);

						 this->Hide();

						 //MessageBox::Show("Hidden and running!");

					 }
					 //IF no time, updates the labe to reflect this, and displays a notification
				 }else{
					 UpdateTime();
					 MessageBox::Show("You're out of time!");
				 }

			 }
			 //Handels the add time button. Opens a dialog box and allows the user to select a data file to upload
	private: void btnAddTime_Click(System::Object ^ sender, System::EventArgs ^ e)
			 {

				 String^ sCurrentDir = Application::StartupPath;
				 sCurrentDir=sCurrentDir->Substring(0,3);
				 sCurrentDir+="Demonstration Package\\SpO2\\Data";
				 openHeartRateFile->InitialDirectory = sCurrentDir;
				 if(openHeartRateFile->ShowDialog() == System::Windows::Forms::DialogResult::OK) //Opens dialog, and runs code when OK is pressed
				 {
					 //Retrieves the path of the file
					 String ^ sPath=openHeartRateFile->FileName;
					 //Opens the file
					 System::IO::StreamReader ^ sr = gcnew System::IO::StreamReader(sPath, System::Text::Encoding::UTF8);
					 //Keep reading lines until the try statement fails, at whichpoint delete the reader
					 try
					 {
						 String^ line;
						 //Clear the first trash line
						 line = sr->ReadLine();
						 // Read and parse HR data from the file until the end of  
						 // the file is reached. 
						 int nLoopCount=0;
						 while ( line = sr->ReadLine() )
						 {
							 if(line->Contains(",")){
								 //String used to build numbers
								 String^ sNumBuilder;
								 //Counter for the for loops
								 int i;
								 //Run though the string and extract the first number
								 for(i=1; i< line->Length; i++){
									 if(line[i]!='"'&&line[i]!=','){
										 sNumBuilder+=line[i];
									 }else{
										 break;
									 }
								 }
								 //Save the extracted number
								 listOxyData->Add(sNumBuilder);
								 //Clear the number builder so it can be reused
								 sNumBuilder="";
								 //Run though the string starting where the last loop left off and extract the second number
								 for(; i< line->Length; i++){
									 if(line[i]!='"'&&line[i]!=','){
										 sNumBuilder+=line[i];
									 }
								 }
								 //Save the extracted number
								 listHRData->Add(sNumBuilder);
								 //Clear the number builder so it can be reused
								 sNumBuilder="";
								 nLoopCount++;
							 }
						 }
					 }
					 finally
					 {
						 if ( sr )
							 delete (IDisposable^)sr;
						 MessageBox::Show("Upload Completed");
						 CalculateCalories();
					 }
					 //Delete the data file so it cannot be reused
					 if ( File::Exists( sPath ) )
					 {
						 File::Delete( sPath );
					 }
				 }
			 }

			 //Handels the timer's tick every minute. Removes the user's time, and if they're out, re opens this main control panel window
	private: System::Void timerSession_Tick(System::Object^  sender, System::EventArgs^  e) {
				 //Ensure time is up to date
				 LoadTime();

				 if(dTime>=1){
					 //Remove daily time if possible
					 dTime--;
				 }else if(dFlexTime>=1){
					 //Remove flex time if daily time is not availible
					 dFlexTime--;
				 }else{
					 //When the user is out of time, show this window, and stop the timer
					 if ( this->WindowState == FormWindowState::Minimized )
						 this->WindowState = FormWindowState::Normal;
					 this->Activate();
					 this->Show();
					 timerSession->Enabled=false;
				 }
				 nTime=(int)(dFlexTime + dTime);
				 //Update the time the user sees, and save it
				 UpdateTime();
				 SaveTime();
			 }
	private: System::Void lblTimeLeft_Click(System::Object^  sender, System::EventArgs^  e) {
			 }
			 //When the form closes, save the current values for time
	private: System::Void FormOutOfTime_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {
				 SaveTime();
			 }

	private: System::Void btnExit_Click(System::Object^  sender, System::EventArgs^  e) {
				 Close();
			 }

	};
}

