#include "FormParentalOverride.h"
#include "FormLauncher.h"
#include "Windows.h"
#include <iostream>
#include "wtypes.h"
//#include <User32.dll>
//#using <User32.dll>
#using <System.dll>
#using <System.Windows.Forms.dll>
#using <System.Drawing.dll>
#pragma once

namespace PurpleHealth {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::IO;
	using namespace System::Text;
	using namespace std;


	/// <summary>
	/* This is basically the main form that the user sees when they first log into the program. It is called "FormOutOfTime"
	because it was initially just meant to pop up when they were out of time, instead of functioning as the general control
	panel it is now. Consider naming it something better. THis form launches FormLauncher form when the user begins a session
	as a way to show of other features of the program. This form also remains open as a task bar icon when the user begins a session
	*/
	/// </summary>
	public ref class FormOutOfTime : public System::Windows::Forms::Form
	{
	protected: 

		//User Defined Variables
		//Tracks user's calories burt (from uploaded data)
	private: static double dCalsBurnt=0;
			 //Tracks the number of calories a user has to burn to gain an hour of time
	private: static double dCalsPerHour=200;
			 //Tempory string to hold stuff
	private: static String ^ sTemp;
			 //Tracks a user's daily time (min)
	private: static double dTime=30;
			 //Tracks a user's flex time (this carries over day to day)(min)
	private: static double dFlexTime=0;
			 //Integer used to hold dTime when a nice, integer output is preferable to a double
	private: static int nTime=0;
			 //Tracks the amount of time a user is allowed per day (before requiring exercise). THis is
			 //not currently used by anything (min)
	private: static double dDailyAllowance=0;
			 //Pointer to the location of the FormLauncher object which is opened when the user begins the session
	private: System::Windows::Forms::Form^ formLauncher;

			 //Machine Defined Variables

	private: System::Windows::Forms::Button^  btnOverride;
	private: System::Windows::Forms::Button^  btnUploadData;

	private: System::Windows::Forms::Button^  btnLogout;

	private: System::Windows::Forms::Label^  lblTimeLeft;
	private: System::Windows::Forms::OpenFileDialog^  openHeartRateFile;
	private: System::ComponentModel::IContainer^  components;
	private: System::Windows::Forms::Button^  btnBeginSession;
	private: System::Windows::Forms::Timer^  timerSession;
	private: System::Windows::Forms::Form^ formParentalOverride;

	private:

		/// <summary>
		/// Required designer variable.
		/// </summary>
	public:
		FormOutOfTime(void)
		{
			//Creater the items on the screen (code generated by visual editor)
			InitializeComponent();
			//Create the tray icon that the user sees and can use when this window is hidden code from MSDN
			CreateTrayIcon();
			//Retrieves the users timing info from the saved file
			LoadTime();
			//Updates the various places that the program shows time
			UpdateTime();


		}
		//Creates the tray icon, and defines its properties
		void CreateTrayIcon()
		{
			this->components2 = gcnew System::ComponentModel::Container;
			this->contextMenu = gcnew System::Windows::Forms::ContextMenu;
			this->menuItemOpen = gcnew System::Windows::Forms::MenuItem;
			this->menuItemTime = gcnew System::Windows::Forms::MenuItem;

			// Initialize contextMenu
			array<System::Windows::Forms::MenuItem^>^temp0 = {this->menuItemOpen};
			this->contextMenu->MenuItems->AddRange( temp0 );
			array<System::Windows::Forms::MenuItem^>^temp1 = {this->menuItemTime};
			this->contextMenu->MenuItems->AddRange( temp1 );

			// Initialize Menu Items
			this->menuItemOpen->Index = 0;
			this->menuItemOpen->Text = "Open";
			this->menuItemOpen->Click += gcnew System::EventHandler( this, &FormOutOfTime::menuItemOpen_Click );

			this->menuItemTime->Index = 1;
			this->menuItemTime->Text = "Check Time";
			this->menuItemTime->Click += gcnew System::EventHandler( this, &FormOutOfTime::menuItemTime_Click );

			// Create the NotifyIcon.
			this->trayIconFormOutOfTime = gcnew System::Windows::Forms::NotifyIcon( this->components2 );

			// The Icon property sets the icon that will appear
			// in the systray for this application.
			trayIconFormOutOfTime->Icon = gcnew System::Drawing::Icon( "clock.ico" );

			// The ContextMenu property sets the menu that will
			// appear when the systray icon is right clicked.
			trayIconFormOutOfTime->ContextMenu = this->contextMenu;

			// The Text property sets the text that will be displayed,
			// in a tooltip, when the mouse hovers over the systray icon.
			trayIconFormOutOfTime->Text = "Balife";
			trayIconFormOutOfTime->Visible = true;

			// Handle the DoubleClick event to activate the form.
			trayIconFormOutOfTime->DoubleClick += gcnew System::EventHandler( this, &FormOutOfTime::trayIconFormOutOfTime_DoubleClick );
		}
	private:
		//Reads user's daily time (dTime), flex time aka anytime-time (dFlexTime), Number of calories required to earn an
		//hour of additional time (dCalsPerHour), and the user's current daily allowance of time (not currently used at all)(dDailyAllowance)
		void LoadTime(){
			//Begin read of the timing file
			System::IO::StreamReader ^ sr = gcnew System::IO::StreamReader("Time.time", System::Text::Encoding::Unicode);
			//Read the info from the file and put in respective global variables (file contains four lines)
			dTime=System::Convert::ToDouble(sr->ReadLine());
			dFlexTime=System::Convert::ToDouble(sr->ReadLine());
			dCalsPerHour=System::Convert::ToDouble(sr->ReadLine());
			dDailyAllowance=System::Convert::ToDouble(sr->ReadLine());
			sr->Close();

		}
		//Updates the label in this form, as well as the tray icon tooltip to say how much time is left
		void GetDesktopResolution(int& horizontal, int& vertical){
		   RECT desktop;
		   // Get a handle to the desktop window
		   const HWND hDesktop = GetDesktopWindow();
		   // Get the size of screen to the variable desktop
		   GetWindowRect(hDesktop, &desktop);
		   // The top left corner will have coordinates (0,0)
		   // and the bottom right corner will have coordinates
		   // (horizontal, vertical)
		   horizontal = desktop.right;
		   vertical = desktop.bottom;
		}
		
		void UpdateTime(){
			nTime = (int)(dTime+dFlexTime);
			if(nTime>0){
				this->lblTimeLeft->Text = L"You have "+nTime+" minutes to browse today.";
				trayIconFormOutOfTime->Text="You have "+nTime+" minutes to browse today.";
			}else{
				this->lblTimeLeft->Text = L"You currently have no time left. Wait until tomorrow, or upload heart rate data to get more time.";
				trayIconFormOutOfTime->Text="Out of Time"; //Cant contain too many characters i.e. above message is too long
			}
		}
		
		//Takes the current timing data and outputs it to the time file (done quite frequenty, since multiple parts of the program rely on
		//up to date info from this file
		void SaveTime(){
			//Define the location of the time info file 
			String^ path = "Time.time";
			//CHeck if file exists, delete if it does (can cause problems, since multiple forms are reading and writing to this file)
			if ( File::Exists( path ) )
			{
				File::Delete( path );
			}

			//Create the file.

			FileStream^ fs = File::Create( path );
			UnicodeEncoding^ uniEncoding = gcnew UnicodeEncoding;
			//Write the timing data to the file in unicade encoding (important to note if you open the file with a
			//tect editor for debugging)
			String^ tempString = System::Convert::ToString(dTime)+"\r";
			fs->Write( uniEncoding->GetBytes( tempString ), 0, uniEncoding->GetByteCount( tempString ) );
			tempString = System::Convert::ToString(dFlexTime)+"\r";
			fs->Write( uniEncoding->GetBytes( tempString ), 0, uniEncoding->GetByteCount( tempString ) );
			tempString = System::Convert::ToString(dCalsPerHour)+"\r";
			fs->Write( uniEncoding->GetBytes( tempString ), 0, uniEncoding->GetByteCount( tempString ) );
			tempString = System::Convert::ToString(dDailyAllowance)+"\r";
			fs->Write( uniEncoding->GetBytes( tempString ), 0, uniEncoding->GetByteCount( tempString ) );
			fs->Close();
		}

//Variables required for tray icon
	private:
		//Icon itself
		System::Windows::Forms::NotifyIcon^ trayIconFormOutOfTime;
		//Menu that comes up on right click
		System::Windows::Forms::ContextMenu^ contextMenu;
		//Items in above menu
		System::Windows::Forms::MenuItem^ menuItemOpen;
		System::Windows::Forms::MenuItem^ menuItemTime;
		//Misc
		System::Windows::Forms::Button^  btnExit;
		System::Windows::Forms::Label^  label1;
		System::ComponentModel::IContainer^ components2;


	private:
		//Handles the event of a double click on the tray icon, action listener 
		void trayIconFormOutOfTime_DoubleClick( Object^ /*Sender*/, EventArgs^ /*e*/ )
		{

			// Show the form when the user double clicks on the notify icon.
			// Set the WindowState to normal if the form is minimized.
			if ( this->WindowState == FormWindowState::Minimized )
				this->WindowState = FormWindowState::Normal;

			// Activate the form.
			this->Activate();
			this->Show();
			//Get newest time data
			LoadTime();
			//Show newest tiem data
			UpdateTime();
			//Stop timer so that hte user doesnt lose any time while in the full screen controol panel (possible avenue for
			//a user to cheat the system?)
			timerSession->Enabled=false;
		}
		//Handles when user clicks the menu item saying "Open": opens the window the same way the double click does (since
		//it's the same code, perhaps ove into a function?)
		void menuItemOpen_Click( Object^ /*Sender*/, EventArgs^ /*e*/ )
		{
			if ( this->WindowState == FormWindowState::Minimized )
				this->WindowState = FormWindowState::Normal;
			// Show the form again
			this->Activate();
			this->Show();
			//Get newest time data
			LoadTime();
			//Show newest tiem data
			UpdateTime();
			//Stop timer so that hte user doesnt lose any time while in the full screen controol panel (possible avenue for
			//a user to cheat the system?)
			timerSession->Enabled=false;

		}
		//handles click of "Time" menue item: shows the user their time remaining in a popup
		void menuItemTime_Click( Object^ /*Sender*/, EventArgs^ /*e*/ )
		{
			//Create pop up dialog with the user's reamaining time
			nTime=(int)(dTime+dFlexTime);
			MessageBox::Show("You have "+nTime+" minutes left.");
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~FormOutOfTime()
		{
			if (components)
			{
				delete components;
			}
		}


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(FormOutOfTime::typeid));
			this->btnOverride = (gcnew System::Windows::Forms::Button());
			this->btnUploadData = (gcnew System::Windows::Forms::Button());
			this->btnLogout = (gcnew System::Windows::Forms::Button());
			this->lblTimeLeft = (gcnew System::Windows::Forms::Label());
			this->openHeartRateFile = (gcnew System::Windows::Forms::OpenFileDialog());
			this->btnBeginSession = (gcnew System::Windows::Forms::Button());
			this->timerSession = (gcnew System::Windows::Forms::Timer(this->components));
			this->btnExit = (gcnew System::Windows::Forms::Button());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->SuspendLayout();
			// 
			// btnOverride
			// 
			this->btnOverride->BackColor = System::Drawing::Color::Transparent;
			this->btnOverride->FlatAppearance->BorderSize = 0;
			this->btnOverride->FlatAppearance->MouseDownBackColor = System::Drawing::Color::DarkGray;
			this->btnOverride->FlatAppearance->MouseOverBackColor = System::Drawing::Color::LightGray;
			this->btnOverride->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->btnOverride->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnOverride.Image")));
			this->btnOverride->Location = System::Drawing::Point(359, 454);
			this->btnOverride->Name = L"btnOverride";
			this->btnOverride->Size = System::Drawing::Size(150, 150);
			this->btnOverride->TabIndex = 5;
			this->btnOverride->UseVisualStyleBackColor = false;
			this->btnOverride->Click += gcnew System::EventHandler(this, &FormOutOfTime::btnOverride_Click);
			// 
			// btnUploadData
			// 
			this->btnUploadData->BackColor = System::Drawing::Color::Transparent;
			this->btnUploadData->BackgroundImageLayout = System::Windows::Forms::ImageLayout::None;
			this->btnUploadData->FlatAppearance->BorderSize = 0;
			this->btnUploadData->FlatAppearance->MouseDownBackColor = System::Drawing::Color::DarkGray;
			this->btnUploadData->FlatAppearance->MouseOverBackColor = System::Drawing::Color::LightGray;
			this->btnUploadData->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->btnUploadData->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnUploadData.Image")));
			this->btnUploadData->Location = System::Drawing::Point(203, 454);
			this->btnUploadData->Name = L"btnUploadData";
			this->btnUploadData->Size = System::Drawing::Size(150, 150);
			this->btnUploadData->TabIndex = 6;
			this->btnUploadData->UseVisualStyleBackColor = false;
			this->btnUploadData->Click += gcnew System::EventHandler(this, &FormOutOfTime::btnAddTime_Click);
			// 
			// btnLogout
			// 
			this->btnLogout->BackColor = System::Drawing::Color::Transparent;
			this->btnLogout->FlatAppearance->BorderSize = 0;
			this->btnLogout->FlatAppearance->MouseDownBackColor = System::Drawing::Color::DarkGray;
			this->btnLogout->FlatAppearance->MouseOverBackColor = System::Drawing::Color::LightGray;
			this->btnLogout->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->btnLogout->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnLogout.Image")));
			this->btnLogout->Location = System::Drawing::Point(671, 454);
			this->btnLogout->Name = L"btnLogout";
			this->btnLogout->Size = System::Drawing::Size(150, 150);
			this->btnLogout->TabIndex = 7;
			this->btnLogout->UseVisualStyleBackColor = false;
			this->btnLogout->Click += gcnew System::EventHandler(this, &FormOutOfTime::btnLogout_Click);
			// 
			// lblTimeLeft
			// 
			this->lblTimeLeft->BackColor = System::Drawing::Color::Transparent;
			this->lblTimeLeft->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->lblTimeLeft->Location = System::Drawing::Point(1, 292);
			this->lblTimeLeft->Name = L"lblTimeLeft";
			this->lblTimeLeft->Size = System::Drawing::Size(1022, 20);
			this->lblTimeLeft->TabIndex = 9;
			this->lblTimeLeft->Text = L"You currently have no time left. Wait until tomorrow, or upload heart rate data t" 
				L"o get more time.";
			this->lblTimeLeft->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->lblTimeLeft->Click += gcnew System::EventHandler(this, &FormOutOfTime::lblTimeLeft_Click);
			// 
			// openHeartRateFile
			// 
			this->openHeartRateFile->DefaultExt = L"bal";
			this->openHeartRateFile->Filter = L"Ballanced Life Files (*.bal)|*.bal";
			this->openHeartRateFile->Title = L"Locate the file Containing Heart Rate Data";
			this->openHeartRateFile->FileOk += gcnew System::ComponentModel::CancelEventHandler(this, &FormOutOfTime::openFileDialog1_FileOk);
			// 
			// btnBeginSession
			// 
			this->btnBeginSession->BackColor = System::Drawing::Color::Transparent;
			this->btnBeginSession->FlatAppearance->BorderSize = 0;
			this->btnBeginSession->FlatAppearance->MouseDownBackColor = System::Drawing::Color::DarkGray;
			this->btnBeginSession->FlatAppearance->MouseOverBackColor = System::Drawing::Color::LightGray;
			this->btnBeginSession->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->btnBeginSession->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"btnBeginSession.Image")));
			this->btnBeginSession->Location = System::Drawing::Point(515, 454);
			this->btnBeginSession->Name = L"btnBeginSession";
			this->btnBeginSession->Size = System::Drawing::Size(150, 150);
			this->btnBeginSession->TabIndex = 10;
			this->btnBeginSession->UseVisualStyleBackColor = false;
			this->btnBeginSession->Click += gcnew System::EventHandler(this, &FormOutOfTime::btnBeginSession_Click);
			// 
			// timerSession
			// 
			this->timerSession->Interval = 60000;
			this->timerSession->Tick += gcnew System::EventHandler(this, &FormOutOfTime::timerSession_Tick);
			// 
			// btnExit
			// 
			this->btnExit->Location = System::Drawing::Point(937, 733);
			this->btnExit->Name = L"btnExit";
			this->btnExit->Size = System::Drawing::Size(75, 23);
			this->btnExit->TabIndex = 11;
			this->btnExit->Text = L"Exit";
			this->btnExit->UseVisualStyleBackColor = true;
			this->btnExit->Click += gcnew System::EventHandler(this, &FormOutOfTime::btnExit_Click);
			// 
			// label1
			// 
			this->label1->BackColor = System::Drawing::Color::Transparent;
			this->label1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label1->Location = System::Drawing::Point(300, 865);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(1000, 20);
			this->label1->TabIndex = 12;
			this->label1->Text = L"Copyright Balife Inc. 2012";
			this->label1->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// FormOutOfTime
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackgroundImage = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"$this.BackgroundImage")));
			this->BackgroundImageLayout = System::Windows::Forms::ImageLayout::Stretch;
			this->ClientSize = System::Drawing::Size(1024, 768);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->btnExit);
			this->Controls->Add(this->btnBeginSession);
			this->Controls->Add(this->lblTimeLeft);
			this->Controls->Add(this->btnLogout);
			this->Controls->Add(this->btnUploadData);
			this->Controls->Add(this->btnOverride);
			this->DoubleBuffered = true;
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::None;
			this->Name = L"FormOutOfTime";
			this->RightToLeftLayout = true;
			this->Text = L"FormOutOfTime";
			this->TopMost = true;
			this->WindowState = System::Windows::Forms::FormWindowState::Maximized;
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &FormOutOfTime::FormOutOfTime_FormClosing);
			this->Load += gcnew System::EventHandler(this, &FormOutOfTime::FormOutOfTime_Load);
			this->ResumeLayout(false);

		}
#pragma endregion
		//Garbage
	private: System::Void openFileDialog1_FileOk(System::Object^  sender, System::ComponentModel::CancelEventArgs^  e) {
			 }
	private: System::Void FormOutOfTime_Load(System::Object^  sender, System::EventArgs^  e) {
			 }

		//Deals with parental overide request. Launches the parental overide form, then when that form is done, reloads and
			 //updates time data
	private: System::Void btnOverride_Click(System::Object^  sender, System::EventArgs^  e) {
				 formParentalOverride = gcnew FormParentalOverride;
				 formParentalOverride->ShowDialog();
				 LoadTime();
				 UpdateTime();

			 }
			 //Handles log off button. Logs out of windows
	private: System::Void btnLogout_Click(System::Object^  sender, System::EventArgs^  e) {
				 ExitWindowsEx(EWX_LOGOFF, SHTDN_REASON_MAJOR_APPLICATION);
				 //ExitWindows(0, 0);
			 }

			 //Handes the begin session button. minimizes to tray if the user has time, tells the user their out if they dont
	private: void btnBeginSession_Click(System::Object ^ sender, System::EventArgs ^ e)

			 {
				 //Figure out the total time the user has available to use
				 nTime=(int)(dFlexTime + dTime);
				 //Do they have any time?
				 //If yes, hide this window, and launch FormLauncher (used for demo purpoes)
				 if(nTime>0){
					 if(!timerSession->Enabled){
						 MessageBox::Show("You have "+nTime+" minutes to browse.");
						 timerSession->Enabled=true;
						 //int nTime=(int)(dTime+dFlexTime);
						 //CSystemTray::MinimiseToTray(this);

						 this->Hide();
						 formLauncher = gcnew FormLauncher;
						 formLauncher->ShowDialog();
						 //MessageBox::Show("Hidden and running!");

					 }
					 //IF no time, updates the labe to reflect this, and displays a notification
				 }else{
					 UpdateTime();
					 MessageBox::Show("You're out of time!");
				 }

			 }
			 //Handels the add time button. Opens a dialog box and allows the user to select a data file to upload
	private: void btnAddTime_Click(System::Object ^ sender, System::EventArgs ^ e)
			 {

				 if(openHeartRateFile->ShowDialog() == System::Windows::Forms::DialogResult::OK) //Opens dialog, and runs code when OK is pressed
				 {
					 //Retrieves the path of the file
					 String ^ sPath=openHeartRateFile->FileName;
					 //Opens the file
					 System::IO::StreamReader ^ sr = gcnew System::IO::StreamReader(sPath, System::Text::Encoding::Unicode);
					 //Increases the calories burnt based on data in file (currenty data is just a number saying calories burnt)
					 dCalsBurnt+=System::Convert::ToDouble(sr->ReadToEnd());
					 //Adds flex time based on calories burnt, and the number of calories required to gan an hour
					 dFlexTime+=dCalsBurnt/(dCalsPerHour/60);
					 sr->Close();
					 //Create integers for visually nice output
					 int nTempCals = (int)dCalsBurnt;
					 int nTempTime = (int)(dCalsBurnt/(dCalsPerHour/60));
					 nTime=(int)(dFlexTime + dTime);
					 //Update label to reflect user's added time
					 this->lblTimeLeft->Text = L"You have burnt "+ nTempCals +" calories giving you " + nTempTime + " additional minutes. You now have "+(nTime)+" minutes remaining.";
					 //Delete the data file so it cannot be reused
					 if ( File::Exists( sPath ) )
					 {
						 File::Delete( sPath );
					 }
					 //Save the uploaded info
					 SaveTime();

				 }
			 }
			 //Handels the timer's tick every minute. Removes the user's time, and if they're out, re opens this main control panel window
	private: System::Void timerSession_Tick(System::Object^  sender, System::EventArgs^  e) {
				 //Ensure time is up to date
				 LoadTime();

				 if(dTime>=1){
					 //Remove daily time if possible
					 dTime--;
				 }else if(dFlexTime>=1){
					 //Remove flex time if daily time is not availible
					 dFlexTime--;
				 }else{
					 //When the user is out of time, show this window, and stop the timer
					 if ( this->WindowState == FormWindowState::Minimized )
						 this->WindowState = FormWindowState::Normal;
					 this->Activate();
					 this->Show();
					 timerSession->Enabled=false;
				 }
				 nTime=(int)(dFlexTime + dTime);
				 //Update the time the user sees, and save it
				 UpdateTime();
				 SaveTime();
			 }
	private: System::Void lblTimeLeft_Click(System::Object^  sender, System::EventArgs^  e) {
			 }
			 //When the form closes, save the current values for time
	private: System::Void FormOutOfTime_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {
				 SaveTime();
			 }

	private: System::Void btnExit_Click(System::Object^  sender, System::EventArgs^  e) {
				 Close();
			 }

	};
}

